
//======================================================================
//
//	Portions written by FreemanSoft Inc.
//
//	FreemanSoft disclaims any warranty of any kind, expressed or implied,
//	as to this source code's fitness for any particular use.
//
//	For more information, use the following electronic mail addresses:
//	 
//		info@FreemanSoft.com	general questions
//		support@FreemanSoft.com	technical questions
//
//======================================================================


/* 
 * PreferencesPanel
 *	Written by
 *	Joe Freeman	jfreeman@next.com	
 *
 *	This code has no warranty.  
 *	It is provided so that the consumer may maintain and modify it
 *	at their own risk.  Use this code at your own risk.
 */

#import <appkit/appkit.h>

@interface PreferencesPanel:Panel
{
    id pathPreference;		/* relative or absolute */
    id methodPreference;	/* remove files on backup not in source dir? */
    id exceptPatText;		/* text object that holds files to be pruned */
    id findWritable;		/* should we do a find before a search */
}

- loadPatternFile:sender;
- savePatternFile:sender;

- changePathPrefer:sender;
- changeMethodPrefer:sender;
- changeFindWritablePrefer:sender;

- getExemptString:(char **)bufPtr length:(int *)length;
@end

/* objects supporting the pref panel should implement these */
@interface PreferencesPanelSupport:Object
{
}
- preferencesChanged:sender;
- (NXStream *)mapResource:(const char *)resourceName;
@end
