
//======================================================================
//
//	Portions written by FreemanSoft Inc.
//
//	FreemanSoft disclaims any warranty of any kind, expressed or implied,
//	as to this source code's fitness for any particular use.
//
//	For more information, use the following electronic mail addresses:
//	 
//		info@FreemanSoft.com	general questions
//		support@FreemanSoft.com	technical questions
//
//======================================================================


/* Written by
 *	Joe Freeman	jfreeman@next.com	
 *	RdistControl
 *
 *	This code has no warranty.  
 *	It is provided so that the consumer may maintain and modify it
 *	at their own risk.  Use this code at your own risk.
 */

#import "TarControl.h"
#import "DragView.h"
#import "Subprocess.h"
#import "pathutil.h"
#import "common.h"
#import "tarControl.h"		// strings entries

#import "JumpBackControl.h"


/*================================================================
 *	Private methods 
 *================================================================*/
 
@implementation TarControl

	

- (const char *)buttonImageName
{
    return "tar_CD.tiff";
}

- (const char *)buttonAltImageName
{
    return "tar_CD_abort.tiff";
}

- (const char *)stringsTable
{
    return "tarControl";
}

- free
{
    [[NXApp delegate] dropDragJumpBackController:self];
    return [super free];
}
	
- runPassOne:sender
{
    /* is no pass one for this app */
    return nil;
}


	
- runPassTwo:sender
{	
    char buf[4096];
    char feathersPath[1024];
    
    canContinue = YES;
    [self setState:PASS_2_RUNNING];
    [self logIt:start_pass_2_string];
    [[NXBundle mainBundle] getPath: feathersPath
			forResource:tar_executable ofType:""];
    sprintf(buf, pass_2_run_string, 
    	sPathList, feathersPath, basename(sPathList), dPathList, feathersPath);
    subprocessObj = [Subprocess new:buf
				withDelegate:self
				andPtySupport:NO
				andStdErr:YES];
    [subprocessObj terminateInput];
    return self;
}


@end
