/*****************************************************************************
 * Controller.h
 * 
 * Authors: 
 * 	Denise Howard
 * 	howardd@swissbank.com
 *
 *	Michael Hawley
 *	mike@media.mit.edu
 *
 * Copyright (c) MIT Media Laboratory, 1991-1995.
 *
 * Description:
 *	This is the app delegate for Opener.
 *
 * Revisions:
 *	See Revision_History.rtfd in project directory HelpOpener.
 *
 * To add new filetypes:
 *	See Modifying.rtfd in project directory HelpOpener.
 *
 *****************************************************************************/
 
#import <objc/Object.h>
#import <appkit/appkit.h>
#import <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#import <dpsclient/dpsclient.h>
#include <ctype.h>
#import "DirPanel.h"
#import "Process.h"
#import "Help.h"

@interface Controller:Object {
    id packButton;
    id packButton2;
    id packCmdText;
    id packPanel;
    id versionTF;
	id tmpDirTF;
	id helpButton;
	id helpObject;
}

/*****************************************************************************/
/* Action methods start here                                                 */
/*****************************************************************************/
- appWillInit:sender;
- appDidInit:sender;
- appWillTerminate:sender;
- (BOOL)appAcceptsAnotherFile:sender;
- removeTmpFiles:sender;
- setTmp:sender;
- (int)appOpenFile:(const char *)filename type:(const char *)aType;
- openRequest:sender;
- (BOOL)scratchFiles;
- (int)iconEntered:(int)windowNum at:(double)x :(double)y iconWindow:(int)iconWindowNum iconX:(double)iconX iconY:(double)iconY iconWidth:(double)iconWidth iconHeight:(double)iconHeight pathList:(char *)pathList;
- processOutput:(char *)s;
- system:(char *)x;
- setDirectory:sender;
- setPackOrUnpack:sender;
- setUnpackSuffix:sender;
- setPackSuffix:sender;
- packFiles:(char *)files;
- cancelPack:sender;
- pack:sender;
- (int)iconReleasedAt:(double)x :(double)y ok:(int *)flag;
- help:sender;
- editTable:sender;
- suggestion:sender;

/*****************************************************************************/
/* Access methods start here                                                 */
/*****************************************************************************/
- (char *)version;

@end
